/*
---------------------------------------------------------
   #  #  #    #===    ###    ##    #
  #    ##     #===   #      #  #    #
   #   #      #===    ###    ##    #
---------------------------------------------------------
Gib Death 1.1

Plugin made by <VeCo>
Special thanks to:
 - IMBA : for removing the death bodies.
 - hateYou : for the optimization

If you modify the code, please DO NOT change the author!
---------------------------------------------------------
Contacts:
e-mail: veco.kn@gmail.com
skype: veco_kn
---------------------------------------------------------
Changes log:
 -> v 1.0 = First release!
 -> v 1.1 = Optimization.
---------------------------------------------------------
Don't forget to visit http://www.amxmodxbg.org :)
---------------------------------------------------------
*/

#include <amxmodx>
#include <fakemeta>
#include <engine>

new hgibs,ggibs,wgibs,mgibs,cgibs,cegibs,cogibs,rgibs,gcvar,material[33]
public plugin_precache()
{
	hgibs = precache_model("models/hgibs.mdl")
	ggibs = precache_model("models/glassgibs.mdl")
	wgibs = precache_model("models/woodgibs.mdl")
	mgibs = precache_model("models/metalplategibs.mdl")
	cgibs = precache_model("models/cindergibs.mdl")
	cegibs = precache_model("models/ceilinggibs.mdl")
	cogibs = precache_model("models/computergibs.mdl")
	rgibs = precache_model("models/rockgibs.mdl")
}

public plugin_init() {
	register_plugin("Gib Death", "1.1", "<VeCo>")
	register_event("DeathMsg","hook_death","a")
	gcvar = register_cvar("gib_type","0")
	register_cvar("gib_version", "1.1", FCVAR_SERVER|FCVAR_SPONLY)
	set_msg_block( get_user_msgid( "ClCorpse" ), BLOCK_SET )
}

public hook_death()
{
	new pl = read_data(2)
	new Float:origin[3]
	set_entity_visibility(pl,0)
	pev(pl,pev_origin,origin)
	gib_death(pl,origin)
}

public gib_death(pl,Float:fOrigin[3])
{
	new origin[3]
	FVecIVec(fOrigin,origin)
	
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(TE_BREAKMODEL)
	write_coord(origin[0])
	write_coord(origin[1])
	write_coord(origin[2] + 24)
	write_coord(16)
	write_coord(16)
	write_coord(16)
	write_coord(random_num(-50,50))
	write_coord(random_num(-50,50))
	write_coord(25)
	write_byte(10)
	
	switch(get_pcvar_num(gcvar))
	{
		case 0:
		{
			switch(random_num(1,8))
			{ 
				case 1: { write_short(hgibs); } 
				case 2: { write_short(ggibs); material[pl] = 2 ;} 
				case 3: { write_short(wgibs); material[pl] = 3 ;} 
				case 4: { write_short(mgibs); material[pl] = 4 ;} 
				case 5: { write_short(cgibs); material[pl] = 5 ;} 
				case 6: { write_short(cegibs); material[pl] = 5 ;} 
				case 7:  { write_short(cogibs); material[pl] = 4 ;} 
				case 8: { write_short(rgibs); material[pl] = 5 ;}
			}
		}
		case 1: { write_short(hgibs); } 
		case 2: { write_short(ggibs); material[pl] = 2 ;} 
		case 3: { write_short(wgibs); material[pl] = 3 ;} 
		case 4: { write_short(mgibs); material[pl] = 4 ;} 
		case 5: { write_short(cgibs); material[pl] = 5 ;} 
		case 6: { write_short(cegibs); material[pl] = 5 ;} 
		case 7: { write_short(cogibs); material[pl] = 4 ;} 
		case 8: { write_short(rgibs); material[pl] = 5 ;}
	}
	
	write_byte(14)
	write_byte(30)
	
	switch(material[pl])
	{
		case 2: { write_byte(0x01); }
		case 3: { write_byte(0x08); }
		case 4: { write_byte(0x02); }
		case 5: { write_byte(0x04); }
		default: write_byte(0)
	}
	
	message_end()
}
